function Create(self)
	self.aimThreshold = 0;
	
	self.sensorRange = 500;
	self.target = nil;
	self.gunOffset = 13;
	
	self.maxSpeed = 10;
	self.acceleration = 0.2;
	self.Vel = Vector(0,0);
	self.RotAngle = 0;
	self.rotFactor = 0.2;
	
	self.gravTester = CreateMOPixel("D43Yosei Grav Tester");
	self.gravTester.Pos = Vector(self.Pos.X, self.Pos.Y - 3);
	self.gravTester.Vel = Vector(0,0);
	MovableMan:AddParticle(self.gravTester);
	self.gravAcc = 0;
	
	self.healTimer = Timer();
	self.healTime = 2000;
	self.maxHealth = 100;
	
	self.activeCamo = false;
	self.maxCamoEnergy = 500;
	self.curCamoEnergy = self.maxCamoEnergy;
	self.camoSwitchTimer = Timer();
	self.camoSwitchTime = 250;
	
	self.meterOffset = Vector(6, -11);
	self.meter = nil;
	self.noMeter = CreateMOSParticle("D2Shinobi No Camo Meter");
	self.noMeter.Pos = self.Pos + self.meterOffset;
	self.noMeter.Frame = self.noMeter.FrameCount - 1;
	MovableMan:AddParticle(self.noMeter);
end

function Update(self)
	if not(self:IsDead()) then
		if self.gravAcc == 0 then
			if self.gravTester.Vel.Y > 0 then
				self.gravAcc = self.gravTester.Vel.Y;
			end
		end
		
		if self.healTimer:IsPastSimMS(self.healTime) then
			self.Health = self.Health + 1;
			if self.Health > self.maxHealth then
				self.Health = self.maxHealth;
			end
			self.healTimer = Timer();
		end

		local ownController = self:GetController();
		
		if ownController:IsState(Controller.PRESS_DOWN) then
			if self.camoSwitchTimer:IsPastSimMS(self.camoSwitchTime) then
				self.camoSwitchTimer = Timer();
			else
				if self.activeCamo then
					self.activeCamo = false;
					self.GetsHitByMOs = true;
					if MovableMan:ValidMO(self.meter) then
						self.meter.Lifetime = 1;
					end
					self.noMeter = CreateMOSParticle("D2Shinobi No Camo Meter");
					self.noMeter.Pos = self.Pos + self.meterOffset;
					self.noMeter.Frame = (self.curCamoEnergy / self.maxCamoEnergy) * (self.noMeter.FrameCount - 1);
					MovableMan:AddParticle(self.noMeter);
					
					local offSound = CreateAEmitter("D2Shinobi Camo Off Sound Emitter");
					offSound.Pos = self.Pos;
					MovableMan:AddParticle(offSound);
				else
					self.activeCamo = true;
					self.GetsHitByMOs = false;
					if MovableMan:ValidMO(self.noMeter) then
						self.noMeter.Lifetime = 1;
					end
					self.meter = CreateMOSParticle("D2Shinobi Camo Meter");
					self.meter.Pos = self.Pos + self.meterOffset;
					self.meter.Frame = (self.curCamoEnergy / self.maxCamoEnergy) * (self.meter.FrameCount - 1);
					MovableMan:AddParticle(self.meter);
					
					local onSound = CreateAEmitter("D2Shinobi Camo On Sound Emitter");
					onSound.Pos = self.Pos;
					MovableMan:AddParticle(onSound);
				end
			end
		end
		
		if self.activeCamo then
			if MovableMan:ValidMO(self.meter) then
				self.meter.Pos = self.Pos + self.meterOffset;
				self.meter.Frame = (self.curCamoEnergy / self.maxCamoEnergy) * (self.meter.FrameCount - 1);
				self.meter:NotResting();
				self.meter.Age = 0;
				self.meter.ToSettle = false;
				self.meter.ToDelete = false;
			end
			self.curCamoEnergy = self.curCamoEnergy - 1;
			if self.curCamoEnergy <= 0 then
				self.curCamoEnergy = 0;
				self.activeCamo = false;
				self.GetsHitByMOs = true;
				if MovableMan:ValidMO(self.meter) then
					self.meter.Lifetime = 1;
				end
				self.noMeter = CreateMOSParticle("D2Shinobi No Camo Meter");
				self.noMeter.Pos = self.Pos + self.meterOffset;
				self.noMeter.Frame = (self.curCamoEnergy / self.maxCamoEnergy) * (self.noMeter.FrameCount - 1);
				MovableMan:AddParticle(self.noMeter);
					
				local offSound = CreateAEmitter("D2Shinobi Camo Off Sound Emitter");
				offSound.Pos = self.Pos;
				MovableMan:AddParticle(offSound);
			end
		else
			if MovableMan:ValidMO(self.noMeter) then
				self.noMeter.Pos = self.Pos + self.meterOffset;
				self.noMeter.Frame = (self.curCamoEnergy / self.maxCamoEnergy) * (self.noMeter.FrameCount - 1);
				self.noMeter:NotResting();
				self.noMeter.Age = 0;
				self.noMeter.ToSettle = false;
				self.noMeter.ToDelete = false;
			end
			self.curCamoEnergy = self.curCamoEnergy + 1;
			if self.curCamoEnergy > self.maxCamoEnergy then
				self.curCamoEnergy = self.maxCamoEnergy;
			end
		end
		
		if not(ownController:IsPlayerControlled(-1)) then
			self:SetControllerMode(Controller.CIM_DISABLED, -1);
			ownController:SetState(Controller.WEAPON_FIRE, false);
			
			if self.target == nil then
				for actor in MovableMan.Actors do
					local distX = actor.Pos.X - self.Pos.X;
					local distY = actor.Pos.Y - (self.Pos.Y + self.gunOffset);
					local distance = math.sqrt(distX ^ 2 , distY ^ 2);
					if actor.Team ~= self.Team and distance <= self.sensorRange and not(actor:IsDead()) and actor.GetsHitByMOs then
						local found = SceneMan:CastMORay(Vector(self.Pos.X, self.Pos.Y + self.gunOffset), Vector(distX, distY), self.ID, Activity.NOTEAM, 128, false, 2);
						local foundRoot = MovableMan:GetRootMOID(found);
						if foundRoot == actor.ID then
							local actorAngle = math.atan2(distY, distX) * -1;
							if actorAngle > math.pi / 2 or actorAngle < math.pi / -2 then
								ownController:SetState(Controller.MOVE_LEFT, true);
							else
								ownController:SetState(Controller.MOVE_RIGHT, true);
							end
							if actorAngle > math.pi / 2 then
								actorAngle = math.pi - actorAngle;
							end
							if actorAngle < math.pi / -2 then
								actorAngle = (math.pi * -1) - actorAngle;
							end
							self.target = actor;
							self:SetAimAngle(actorAngle);
							ownController:SetState(Controller.WEAPON_FIRE, true);
							
							break;
						end
					end
				end
			else
				if MovableMan:ValidMO(self.target) then
					local distX = self.target.Pos.X - self.Pos.X;
					local distY = self.target.Pos.Y - (self.Pos.Y + self.gunOffset);
					local distance = math.sqrt(distX ^ 2 , distY ^ 2);
					local found = SceneMan:CastMORay(Vector(self.Pos.X, self.Pos.Y + self.gunOffset), Vector(distX, distY), self.ID, Activity.NOTEAM, 128, false, 2);
					local foundRoot = MovableMan:GetRootMOID(found);
					if self.target:IsDead() or foundRoot ~= self.target.ID or distance > self.sensorRange or not(self.target.GetsHitByMOs) then
						self.target = nil;
					else
						local targetVector = Vector(0,0);
						targetVector.X = self.target.Pos.X - self.Pos.X;
						targetVector.Y = self.target.Pos.Y - (self.Pos.Y + self.gunOffset);
						
						local targetAngle = math.atan2(targetVector.Y, targetVector.X) * -1;
						if targetAngle > math.pi / 2 or targetAngle < math.pi / -2 then
							ownController:SetState(Controller.MOVE_LEFT, true);
						else
							ownController:SetState(Controller.MOVE_RIGHT, true);
						end
						if targetAngle > math.pi / 2 then
							targetAngle = math.pi - targetAngle;
						end
						if targetAngle < math.pi / -2 then
							targetAngle = (math.pi * -1) - targetAngle;
						end
						self:SetAimAngle(targetAngle);
						ownController:SetState(Controller.WEAPON_FIRE, true);
					end
				else
					self.target = nil;
				end
			end
		end
		
		if self:GetAimAngle(false) > self.aimThreshold then
			ownController:SetState(Controller.WEAPON_FIRE, false);
			self:SetAimAngle(self.aimThreshold);
			self.target = nil;
		end
		
		if ownController:IsState(Controller.HOLD_LEFT) then
			self.Vel.X = self.Vel.X - self.acceleration;
			if self.Vel.X < -self.maxSpeed then
				self.Vel.X = -self.maxSpeed;
			end
		elseif ownController:IsState(Controller.HOLD_RIGHT) then
			self.Vel.X = self.Vel.X + self.acceleration;
			if self.Vel.X > self.maxSpeed then
				self.Vel.X = self.maxSpeed;
			end
		elseif self.Vel.X < 0 then
			self.Vel.X = self.Vel.X + self.acceleration;
			if self.Vel.X > 0 then
				self.Vel.X = 0;
			end
		elseif self.Vel.X > 0 then
			self.Vel.X = self.Vel.X - self.acceleration;
			if self.Vel.X < 0 then
				self.Vel.X = 0;
			end
		end
		if ownController:IsState(Controller.HOLD_UP) then
			self.Vel.Y = self.Vel.Y - self.acceleration;
			if self.Vel.Y < -self.maxSpeed then
				self.Vel.Y = -self.maxSpeed;
			end
		elseif ownController:IsState(Controller.HOLD_DOWN) then
			self.Vel.Y = self.Vel.Y + self.acceleration;
			if self.Vel.Y > self.maxSpeed then
				self.Vel.Y = self.maxSpeed;
			end
		elseif self.Vel.Y < 0 then
			self.Vel.Y = self.Vel.Y + self.acceleration;
			if self.Vel.Y > 0 then
				self.Vel.Y = 0;
			end
		elseif self.Vel.Y > 0 then
			self.Vel.Y = self.Vel.Y - self.acceleration;
			if self.Vel.Y < 0 then
				self.Vel.Y = 0;
			end
		end
		
		self.Vel.Y = self.Vel.Y - self.gravAcc;
		
		self.RotAngle = self.rotFactor * -(self.Vel.X / self.maxSpeed);
	end
end